#!/usr/bin/env ruby
#	
#   This program is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#   This program is distributed in the hope that it will be useful,
#   but WITHOUT ANY WARRANTY; without even the implied warranty of
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#   GNU General Public License for more details.
#
#   You should have received a copy of the GNU General Public License
#   along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
#	Copyright Alain Pernelle

# Project:  www.alpern.free.fr
# Website: http://www.alpern.free.fr

# Quick documentation: use -h option

# TODO
# - keep name of save file with date.
# Bug with Cisco Device Special password charatere

require 'thread'
require 'rubygems'
require 'optiflag'
require 'net/telnet'

module Example  extend OptiFlagSet
  usage_flag "h","help","?"
  flag "H" do
    long_form "Host"
    description "Host, Cible Equipement Cisco "
  end
  flag "u" do
    long_form "username"
    description "username "
  end
  flag "p" do
    long_form "password"
    description "password "
  end
  flag "f" do
    long_form "enable"
    description "enable password "
  end
  optional_flag "c" do
    long_form "critical"
    description "--critical, default 60,  Critical time (s)"
  end
  optional_flag "w" do
    long_form "warn"
    description "--warn, default 5,  warn time (s)"
  end
  optional_switch_flag "e" do
    description "extended mode, see the documentation"
  end 
  and_process!
end 

# GET THE ARGV VALUES
if ARGV.flags.e?
  EXTENDED=1
else
  EXTENDED=0
end
# Get Require Arguments 
  username=ARGV.flags.u
  password=ARGV.flags.p
  enablepassword=ARGV.flags.f
  peer=ARGV.flags.H
# Get Optional arguments
if ARGV.flags.c?
  timeCritical=ARGV.flags.c.to_f
else
  timeCritical=60
end

if ARGV.flags.w?
  timeWarn=ARGV.flags.w.to_f
else
  timeWarn=5
end
begin
#Message de login attendu Username: ou Password:
login_prompt = /[: ]*\z/n
password_prompt = /[: ]*\z/n

fichier=(peer)

#hash pour passer les paramèes àa méode login du telnet s'il on n'utilise pas de hash on ne peux que passer le username et password
#cette méode permet de choisir le login prompt et le password prompt attendu selon les éipements.
para = {
    "Name"          => username,
    "Password"  => password,
    "LoginPrompt"         => login_prompt,
    "PasswordPrompt"           => password_prompt
}

localhost = Net::Telnet::new("Host" => peer,
                               "Timeout" => 25,
                               "Prompt" => /[#>]/n
                                                            )
#  localhost.login(username,password) { |c| print c }
# Si le switches ou le router propose directement de taper le password
#  if username == password
#      localhost.waitfor(/[U]nk/n)
#          else
#  end
  localhost.login(para)
  localhost.puts("enable")
  localhost.cmd(enablepassword)
  localhost.cmd("term leng 0")  
  line = localhost.cmd("sh running")
  localhost.cmd("exit") 
  localhost.close  { |c| print c }

# Code de retour vers Nagios voir si line est vide
if line
  SortieFile = File.new("/var/log/nagios/"+fichier + ".confg", "w")
  SortieFile.puts(line)
  SortieFile.close
  retCode=0
  retCodeLabel="OK"
  print "#{retCodeLabel}"
  exit retCode
else
  retCode=2
  retCodeLabel="Critical"
  print "#{retCodeLabel}"
  exit retCode
end
rescue SystemCallError
  retCode=2
  retCodeLabel="Critical"
  print "#{retCodeLabel}"
  print "Erreur dans le programe"
  exit retCode
## print the script result for nagios
###############################################################
print "#{retCodeLabel}"
exit retCode
end 
